var express = require('express');
var router = express.Router();
const axios = require('axios')
const FormData = require('form-data')
const host = 'www.allteaching.biz'
const origin = 'https://' + host
const referer = host + '/lms/plugin/player/ecom_player.php'
const contentType = 'application/x-www-form-urlencoded; charset=UTF-8'
const updateUrl = origin + '/lms/plugin/player/ecom_player_update.php'

router.get('/', function(req, res, next) {
  res.render('index', { title: 'Vazil Eduline Skipper' });
});


router.post('/skip', async (req, res, next) => {
  try {
    const { PHPSESSID, key, p_id, s_id, wr_id} = req.body

    let responses = []

    for(let i = 0; i < 14; i++) {
      let response = {
        start: false,
        end: false
      }

      let rand = parseInt((Math.random() * 10000) + 1000000)
      
      let startTimestamp = ((parseInt(Date.now()) - rand) + '').substring(0, 10)
      console.log(i + ' 번째 요청 ', startTimestamp)

      const playCookie = encodeURIComponent(JSON.stringify({
        wr_id: wr_id,
        p_id: p_id,
        s_id: s_id,
        wr_order: 22,
        sample_mode: false
      }));

      const pageTimeCookie = encodeURIComponent(JSON.stringify({
        key: key ? key : '66592ddb19920',
        time: startTimestamp
      }));

      let cookie = ''
      cookie += 'PHPSESSID=' + (PHPSESSID ? PHPSESSID : 'w6~gaf4ngqb42nslt97tuqbcegph1') + ';'
      cookie += 'play=' + playCookie + ';'
      cookie += 'page_time=' + pageTimeCookie

      const config = {
        headers: {
          'Origin': origin,
          'Host': host,
          'Referer': referer,
          'Content-Type': contentType
        }
      }

      config.headers['Cookie'] = cookie

      const formData = new FormData()
      formData.append('p_id', p_id)
      formData.append('s_id', s_id)
      formData.append('wr_order', 22)
      formData.append('wr_page', (i+1))
      formData.append('wr_id', wr_id)
      await axios.post(updateUrl, formData, config)
      .then(res=>{
        console.log('start clear', res.data)
        response = res.data
      })
      .catch(err=>{
        console.log('start error', err)
      })

      responses.push(response)
    }
    
    res.status(200).json(responses)
    
  } catch (err) {
    console.error(err);
    next(err)
  }
})

// health
router.get('/health', function(req, res, next) {
  res.status(200).json('ok')
})

module.exports = router;
